package j2d.transforms;

import futils.Futil;
import j2d.ImageUtils;
import math.fourierTransforms.pfa.FFTImage;

import javax.media.jai.*;
import java.awt.*;
import java.awt.image.DataBuffer;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.ParameterBlock;
import java.io.File;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Oct 31, 2005
 * Time: 12:05:39 PM
 */

public class FFTImageExample {
    private File readFile;
    private Image img;
    private FFTImage fftImage;
    private Image kernalImage;

    public FFTImageExample() {
        readFile = Futil.getReadFile("select an image(try baboon)");
        img = ImageUtils.getImage(readFile);
        ImageUtils.displayImage(img, "input image");
        fftImage = new FFTImage(img);
        fftImage.fft();
        ImageUtils.displayImage(
                //ImageUtils.unahe(
                fftImage.getImage(), "fft psd image");
        //fftImage.ifft();
        //ImageUtils.displayImage(fftImage.getImage(),"Filtered image");
        kernalImage = ImageUtils.getImage(Futil.getReadFile("select a kernal image"));
        ImageUtils.displayImage(kernalImage, "Kernal Image (try circle)");
        FFTImage kernalFft = new FFTImage(kernalImage);
        kernalFft.fft();
        ImageUtils.displayImage(ImageUtils.unahe(kernalFft.getImage()), "fft of kernal image");
        Image filteredImage = FFTImage.filter(img, kernalImage);
        ImageUtils.displayImage(filteredImage,
                //ImageUtils.unahe(filteredImage),
                "filtered image");

    }

    /*
        dft1 = DFT(image1)
        psdft1 = PeriodicShift(dft1)
        product = psdft1*image2
        dft2 = PeriodicShift(product)
        output = IDFT(dft2)

    */
    public static void main(String[] args) {
        new FFTImageExample();
    }

}
